/*
 * PDIRECT.H
 * 1991-12-14
 *
 * Lee Daniel Crocker           lee@mport.com (uunet!mport!lee)
 * 5506 Camden Ave #D3          73407.2030@compuserve.com
 * San Jose, CA  95124
 *
 * Portable directory reading functions.  See PDIRECT.C for usage.
 */

#include <stdio.h>
#include <time.h>
#include <string.h>

/*
 * OS-specific definitions.
 */

#if defined(MSDOS)

#ifdef __TURBOC__                   /* Both Turbo and MS C have these */
# include <dir.h>                   /* functions, but Borland naturally */
# define find_t ffblk               /* renamed everything. */
# define _dos_findfirst findfirst
# define _dos_findnext findnext
#else
# define ff_attrib attrib
# define ff_ftime wr_time
# define ff_fdate wr_date
# define ff_fsize size
# define ff_name name
#endif

#include <dos.h>

typedef struct {
    char path[FILENAME_MAX];
    char *basep;
    int first_time;
    struct find_t dta;
} Directory;

typedef struct {
    unsigned short d_mode;
    long d_size;
    time_t d_time;
    char d_name[14];
} DirEntry;

#define IS_DIR(de) ((((de).d_mode)&(_A_SUBDIR))!=0)
#define IS_REG(de) ((((de).d_mode)& \
    (_A_SUBDIR|_A_HIDDEN|_A_SYSTEM|_A_VOLID))==0)

#elif defined(UNIX)

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

typedef struct {
    char path[FILENAME_MAX];
    char *basep;
    DIR *dp;
} Directory;

typedef struct {
    unsigned short d_mode;
    long d_size;
    time_t d_time;
    char d_name[256];
} DirEntry;

#define IS_DIR(de) S_ISDIR((de).d_mode)
#define IS_REG(de) S_ISREG((de).d_mode)

#else /* Not MSDOS or UNIX */

#endif

/*
 * Prototypes
 */

int dir_open(Directory *, char *);
int dir_next(Directory *, DirEntry *);
void dir_close(Directory *);
